<script setup lang="ts">
  import { ListingFilter } from '@shopware-pwa/types';
  import { useVuelidate } from '@vuelidate/core';
  import { between } from '@vuelidate/validators';

  const emits = defineEmits<{
    (e: 'update:modelValue', value: (number | undefined)[]): void;
  }>();

  const props = defineProps<{
    filter: ListingFilter;
    modelValue: (number | undefined)[];
  }>();

  const labelName = ref(props.filter.label);

  const { getFormattedPrice } = usePrice();

  const prices = reactive<{ min: number | undefined; max: number | undefined }>({
    min: undefined,
    max: undefined,
  });

  const rules = computed(() => ({
    min: {
      between: between(+(props.filter?.min ?? 0), +(props.modelValue[1] ?? props.filter?.max ?? 0)),
    },
    max: {
      between: between(+(props.modelValue[0] ?? props.filter?.min ?? 0), +(props.filter?.max ?? 0)),
    },
  }));

  const $v = useVuelidate(rules, prices);

  watch(
    () => props.modelValue,
    () => {
      if (props.modelValue?.length) {
        const [min, max] = props.modelValue;
        if (prices.min !== min) {
          prices.min = min;
        }
        if (prices.max !== max) {
          prices.max = max;
        }
        renderLabelName();
      }
    },
    {
      deep: true,
    },
  );

  const onPriceChange = async (key: string, e: any) => {
    const value = +e.target?.value;
    if (key === 'min') {
      prices.min = value;
    } else if (key === 'max') {
      prices.max = value;
    }
    await $v.value.$validate();
    debounceChange();
  };

  const debounceChange = useDebounceFn(() => {
    if (!$v.value.$invalid) {
      renderLabelName();
      emits('update:modelValue', [prices.min, prices.max]);
    }
  }, 350);

  const renderLabelName = () => {
    let text = '';
    if (!prices?.min && !prices.max) text = '';
    if (!prices?.min && prices.max) text = `(<= ${getFormattedPrice(prices.max)})`;
    if (prices?.min && !prices.max) text = `(>= ${getFormattedPrice(prices.min)})`;
    if (prices?.min && prices.max) {
      text = `(${getFormattedPrice(prices.min)} - ${getFormattedPrice(prices.max)})`;
    }
    labelName.value = `${props.filter.label} ${text}`;
  };
</script>

<template>
  <SwDropdownFiltering :label="labelName" :has-value="prices?.min || prices.max">
    <template #content>
      <div class="flex gap-4">
        <div class="flex-1">
          <div
            :class="{
              'text-crimson-500': $v.min?.$error,
            }"
          >
            {{ $t('min') }}
          </div>
          <input
            id="min-price"
            type="number"
            name="min-price"
            :class="[
              'border-border focus:(ring-offset-0 border-primary) block w-full flex-1 rounded-md border px-2 text-sm',
              {
                '!border-crimson-500': $v.min?.$error,
              },
            ]"
            :placeholder="
              parseFloat(`${filter?.min ?? 0}`)
                ?.toFixed(2)
                .toString()
            "
            :value="prices.min"
            @input="(e) => onPriceChange('min', e)"
          />
        </div>
        <div class="flex-1">
          <div
            :class="{
              'text-crimson-500': $v.max?.$error,
            }"
          >
            {{ $t('max') }}
          </div>
          <input
            id="max-price"
            type="number"
            name="max-price"
            :class="[
              'border-border focus:(ring-offset-0 border-primary) block w-full flex-1 rounded-md border px-2 text-sm',
              {
                '!border-crimson-500': $v.max?.$error,
              },
            ]"
            :value="prices.max"
            :placeholder="
              parseFloat(`${filter?.max ?? 0}`)
                ?.toFixed(2)
                .toString()
            "
            @input="(e) => onPriceChange('max', e)"
          />
        </div>
      </div>
      <p v-if="$v.min?.$error" class="text-(crimson-500 xs) mt-1">
        {{
          $t('validation.between', {
            field: $t('form.minValue'),
            min: getFormattedPrice($v.min?.between?.$params?.min),
            max: getFormattedPrice($v.min?.between?.$params?.max),
          })
        }}
      </p>
      <p v-if="$v.max?.$error" class="text-(crimson-500 xs) mt-1">
        {{
          $t('validation.between', {
            field: $t('form.maxValue'),
            min: getFormattedPrice($v.max?.between?.$params?.min),
            max: getFormattedPrice($v.max?.between?.$params?.max),
          })
        }}
      </p>
    </template>
  </SwDropdownFiltering>
</template>
